<template>
  <div v-if="textarea" class="w-full h-full flex items-center justify-center p-4">
    <div v-if="base" v-html="text" :class="[`text-${color}`, getFontWeight(), getFontSize()]" />
  </div>

  <p v-else :class="[`text-${color}`, getFontWeight(), getFontSize()]">
    <slot>
      On sait depuis longtemps que travailler avec du texte lisible et contenant du sens est source de distractions, et empêche de se concentrer sur la mise en page elle-même. L'avantage du Lorem Ipsum sur un texte générique comme 'Du texte. Du texte.
    </slot>
  </p>
</template>

<script setup>
const props = defineProps({
  bodyLarge: { type: Boolean, default: false },
  bodyMedium: { type: Boolean, default: false },
  subtitleLarge: { type: Boolean, default: false },
  subtitleMedium: { type: Boolean, default: false },
  textarea: { type: Boolean, default: false },
  caption: { type: Boolean, default: false },
  button: { type: Boolean, default: false },
  overline: { type: Boolean, default: false },
  regular: { type: Boolean, default: false },
  medium: { type: Boolean, default: false },
  bold: { type: Boolean, default: false },
  text: { type: String, default: '' },
  color: { type: String, default: 'onSurface' },
})

const getFontWeight = () => {
  if (props?.regular) {
    return 'font-weight-regular'
  }
  else if (props?.medium) {
    return 'font-weight-medium'
  }
  else if (props?.bold) {
    return 'font-weight-bold'
  }
}

const getFontSize = () => {
  if (props?.bodyLarge) {
    return 'text-body-1'
  } else if (props?.bodyMedium) {
    return 'text-body-2'
  } else if (props?.subtitleLarge) {
    return 'text-subtitle-1'
  } else if (props?.subtitleMedium) {
    return 'text-subtitle-2'
  } else if (props?.caption) {
    return 'text-caption'
  } else if (props?.overline) {
    return 'text-overline'
  } else if (props?.button) {
    return 'text-button'
  }
}
</script>
